From d0fe8fd01299a8f2870aecee9e0bb72893e87adc Mon Sep 17 00:00:00 2001
From: Sebastian Pop <spop@amazon.com>
Date: Thu, 15 Jul 2021 23:23:37 +0000
Subject: [PATCH] [arm64] port sad

            sad[  4x4]	10.11x 	 6.50     	 65.72
            sad[  8x8]	28.95x 	 8.50     	 246.00
            sad[  8x4]	23.03x 	 5.45     	 125.43
            sad[  4x8]	12.09x 	 10.64    	 128.68
            sad[16x16]	53.37x 	 19.19    	 1024.05
            sad[ 16x8]	43.09x 	 11.62    	 500.84
            sad[ 8x16]	31.03x 	 16.87    	 523.44
            sad[ 16x4]	39.73x 	 6.27     	 249.10
            sad[16x12]	50.55x 	 15.10    	 763.44
            sad[ 4x16]	14.23x 	 19.39    	 275.91
            sad[12x16]	33.68x 	 22.95    	 772.81
            sad[32x32]	62.10x 	 64.84    	 4026.97
            sad[32x16]	59.82x 	 33.74    	 2018.56
            sad[16x32]	57.94x 	 35.01    	 2028.17
            sad[ 32x8]	53.98x 	 18.77    	 1013.48
            sad[32x24]	61.29x 	 49.36    	 3024.90
            sad[ 8x32]	31.84x 	 32.49    	 1034.56
            sad[24x32]	53.61x 	 56.39    	 3022.97
            sad[64x64]	65.24x 	 255.86   	 16692.29
            sad[64x32]	61.77x 	 131.16   	 8100.90
            sad[32x64]	62.31x 	 128.90   	 8031.79
            sad[64x16]	60.28x 	 67.35    	 4060.31
            sad[64x48]	62.53x 	 193.59   	 12104.64
            sad[16x64]	61.10x 	 66.13    	 4040.26
            sad[48x64]	61.75x 	 194.68   	 12022.14
---
 source/common/aarch64/asm-primitives.cpp |  27 +++
 source/common/aarch64/pixel.h            |  27 +++
 source/common/aarch64/sad-a.S            | 291 +++++++++++++++++++++++
 3 files changed, 345 insertions(+)

diff --git a/source/common/aarch64/asm-primitives.cpp b/source/common/aarch64/asm-primitives.cpp
index 5a582b6..3b7e7b1 100644
--- a/source/common/aarch64/asm-primitives.cpp
+++ b/source/common/aarch64/asm-primitives.cpp
@@ -161,6 +161,33 @@ void setupAssemblyPrimitives(EncoderPrimitives &p, int cpuMask)
         p.pu[LUMA_64x48].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_64x48_neon);
         p.pu[LUMA_64x64].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_64x64_neon);
 
+        // sad
+        p.pu[LUMA_4x4].sad    = PFX(pixel_sad_4x4_neon);
+        p.pu[LUMA_4x8].sad    = PFX(pixel_sad_4x8_neon);
+        p.pu[LUMA_4x16].sad   = PFX(pixel_sad_4x16_neon);
+        p.pu[LUMA_8x4].sad    = PFX(pixel_sad_8x4_neon);
+        p.pu[LUMA_8x8].sad    = PFX(pixel_sad_8x8_neon);
+        p.pu[LUMA_8x16].sad   = PFX(pixel_sad_8x16_neon);
+        p.pu[LUMA_8x32].sad   = PFX(pixel_sad_8x32_neon);
+        p.pu[LUMA_16x4].sad   = PFX(pixel_sad_16x4_neon);
+        p.pu[LUMA_16x8].sad   = PFX(pixel_sad_16x8_neon);
+        p.pu[LUMA_16x16].sad  = PFX(pixel_sad_16x16_neon);
+        p.pu[LUMA_16x12].sad  = PFX(pixel_sad_16x12_neon);
+        p.pu[LUMA_16x32].sad  = PFX(pixel_sad_16x32_neon);
+        p.pu[LUMA_16x64].sad  = PFX(pixel_sad_16x64_neon);
+        p.pu[LUMA_32x8].sad   = PFX(pixel_sad_32x8_neon);
+        p.pu[LUMA_32x16].sad  = PFX(pixel_sad_32x16_neon);
+        p.pu[LUMA_32x32].sad  = PFX(pixel_sad_32x32_neon);
+        p.pu[LUMA_32x64].sad  = PFX(pixel_sad_32x64_neon);
+        p.pu[LUMA_32x24].sad  = PFX(pixel_sad_32x24_neon);
+        p.pu[LUMA_64x16].sad  = PFX(pixel_sad_64x16_neon);
+        p.pu[LUMA_64x32].sad  = PFX(pixel_sad_64x32_neon);
+        p.pu[LUMA_64x64].sad  = PFX(pixel_sad_64x64_neon);
+        p.pu[LUMA_64x48].sad  = PFX(pixel_sad_64x48_neon);
+        p.pu[LUMA_12x16].sad  = PFX(pixel_sad_12x16_neon);
+        p.pu[LUMA_24x32].sad  = PFX(pixel_sad_24x32_neon);
+        p.pu[LUMA_48x64].sad  = PFX(pixel_sad_48x64_neon);
+
         // vertical interpolation filters
         p.pu[LUMA_4x4].luma_vpp     = PFX(interp_8tap_vert_pp_4x4_neon);
         p.pu[LUMA_4x8].luma_vpp     = PFX(interp_8tap_vert_pp_4x8_neon);
diff --git a/source/common/aarch64/pixel.h b/source/common/aarch64/pixel.h
index 179c2f4..8065b4a 100644
--- a/source/common/aarch64/pixel.h
+++ b/source/common/aarch64/pixel.h
@@ -2,6 +2,7 @@
  * Copyright (C) 2020 MulticoreWare, Inc
  *
  * Authors: Hongbin Liu <liuhongbin1@huawei.com>
+ *          Sebastian Pop <spop@amazon.com>
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -24,6 +25,32 @@
 #ifndef X265_I386_PIXEL_AARCH64_H
 #define X265_I386_PIXEL_AARCH64_H
 
+int x265_pixel_sad_4x4_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_4x8_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_4x16_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_8x4_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_8x8_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_8x16_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_8x32_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_16x4_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_16x8_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_16x16_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_16x12_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_16x32_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_16x64_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_32x8_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_32x16_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_32x32_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_32x64_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_32x24_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_64x16_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_64x32_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_64x64_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_64x48_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_12x16_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_24x32_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_48x64_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+
 void x265_pixel_avg_pp_4x4_neon (pixel* dst, intptr_t dstride, const pixel* src0, intptr_t sstride0, const pixel* src1, intptr_t sstride1, int);
 void x265_pixel_avg_pp_4x8_neon (pixel* dst, intptr_t dstride, const pixel* src0, intptr_t sstride0, const pixel* src1, intptr_t sstride1, int);
 void x265_pixel_avg_pp_4x16_neon (pixel* dst, intptr_t dstride, const pixel* src0, intptr_t sstride0, const pixel* src1, intptr_t sstride1, int);
diff --git a/source/common/aarch64/sad-a.S b/source/common/aarch64/sad-a.S
index c27cce5..c901996 100644
--- a/source/common/aarch64/sad-a.S
+++ b/source/common/aarch64/sad-a.S
@@ -2,6 +2,7 @@
  * Copyright (C) 2020 MulticoreWare, Inc
  *
  * Authors: Hongbin Liu <liuhongbin1@huawei.com>
+ *          Sebastian Pop <spop@amazon.com>
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -29,6 +30,292 @@
 
 .text
 
+.macro SAD_START_4
+    ld1        {v1.s}[0], [x2], x3
+    ld1        {v0.s}[0], [x0], x1
+    ld1        {v1.s}[1], [x2], x3
+    ld1        {v0.s}[1], [x0], x1
+    uabdl       v16.8h,  v0.8b,  v1.8b
+.endm
+
+.macro SAD_4
+    ld1        {v1.s}[0], [x2], x3
+    ld1        {v0.s}[0], [x0], x1
+    ld1        {v1.s}[1], [x2], x3
+    ld1        {v0.s}[1], [x0], x1
+    uabal       v16.8h,  v0.8b,  v1.8b
+.endm
+
+.macro SAD_START_8
+    ld1         {v1.8b}, [x2], x3
+    ld1         {v0.8b}, [x0], x1
+    ld1         {v3.8b}, [x2], x3
+    ld1         {v2.8b}, [x0], x1
+    uabdl       v16.8h,  v0.8b,  v1.8b
+    uabdl       v17.8h,  v2.8b,  v3.8b
+.endm
+
+.macro SAD_8
+    ld1         {v1.8b}, [x2], x3
+    ld1         {v0.8b}, [x0], x1
+    ld1         {v3.8b}, [x2], x3
+    ld1         {v2.8b}, [x0], x1
+    uabal       v16.8h,  v0.8b,  v1.8b
+    uabal       v17.8h,  v2.8b,  v3.8b
+.endm
+
+.macro SAD_START_16
+    ld1         {v1.16b}, [x2], x3
+    ld1         {v0.16b}, [x0], x1
+    ld1         {v3.16b}, [x2], x3
+    ld1         {v2.16b}, [x0], x1
+    uabdl       v16.8h,  v0.8b,  v1.8b
+    uabdl2      v17.8h,  v0.16b, v1.16b
+    uabal       v16.8h,  v2.8b,  v3.8b
+    uabal2      v17.8h,  v2.16b, v3.16b
+.endm
+
+.macro SAD_16
+    ld1         {v1.16b}, [x2], x3
+    ld1         {v0.16b}, [x0], x1
+    ld1         {v3.16b}, [x2], x3
+    ld1         {v2.16b}, [x0], x1
+    uabal       v16.8h,  v0.8b,  v1.8b
+    uabal2      v17.8h,  v0.16b, v1.16b
+    uabal       v16.8h,  v2.8b,  v3.8b
+    uabal2      v17.8h,  v2.16b, v3.16b
+.endm
+
+.macro SAD_START_32
+    movi        v16.16b, #0
+    movi        v17.16b, #0
+    movi        v18.16b, #0
+    movi        v19.16b, #0
+.endm
+
+.macro SAD_32
+    ld1         {v0.16b-v1.16b}, [x0], x1
+    ld1         {v2.16b-v3.16b}, [x2], x3
+    ld1         {v4.16b-v5.16b}, [x0], x1
+    ld1         {v6.16b-v7.16b}, [x2], x3
+    uabal       v16.8h,  v0.8b,  v2.8b
+    uabal2      v17.8h,  v0.16b, v2.16b
+    uabal       v18.8h,  v1.8b,  v3.8b
+    uabal2      v19.8h,  v1.16b, v3.16b
+    uabal       v16.8h,  v4.8b,  v6.8b
+    uabal2      v17.8h,  v4.16b, v6.16b
+    uabal       v18.8h,  v5.8b,  v7.8b
+    uabal2      v19.8h,  v5.16b, v7.16b
+.endm
+
+.macro SAD_END_32
+    add         v16.8h, v16.8h, v17.8h
+    add         v17.8h, v18.8h, v19.8h
+    add         v16.8h, v16.8h, v17.8h
+    uaddlv      s0,  v16.8h
+    fmov        w0,  s0
+    ret
+.endm
+
+.macro SAD_START_64
+    movi        v16.16b, #0
+    movi        v17.16b, #0
+    movi        v18.16b, #0
+    movi        v19.16b, #0
+    movi        v20.16b, #0
+    movi        v21.16b, #0
+    movi        v22.16b, #0
+    movi        v23.16b, #0
+.endm
+
+.macro SAD_64
+.rept 2
+    ld1         {v0.16b-v3.16b}, [x0], x1
+    ld1         {v4.16b-v7.16b}, [x2], x3
+    uabal       v16.8h,  v0.8b,  v4.8b
+    uabal2      v17.8h,  v0.16b, v4.16b
+    uabal       v18.8h,  v1.8b,  v5.8b
+    uabal2      v19.8h,  v1.16b, v5.16b
+    uabal       v20.8h,  v2.8b,  v6.8b
+    uabal2      v21.8h,  v2.16b, v6.16b
+    uabal       v22.8h,  v3.8b,  v7.8b
+    uabal2      v23.8h,  v3.16b, v7.16b
+.endr
+.endm
+
+.macro SAD_END_64
+    add         v16.8h, v16.8h, v17.8h
+    add         v17.8h, v18.8h, v19.8h
+    add         v16.8h, v16.8h, v17.8h
+    uaddlv      s0,  v16.8h
+    fmov        w0,  s0
+    add         v18.8h, v20.8h, v21.8h
+    add         v19.8h, v22.8h, v23.8h
+    add         v17.8h, v18.8h, v19.8h
+    uaddlv      s1,  v17.8h
+    fmov        w1,  s1
+    add         w0, w0, w1
+    ret
+.endm
+
+.macro SAD_START_12
+    movrel      x12, sad12_mask
+    ld1         {v31.16b}, [x12]
+    movi        v16.16b, #0
+    movi        v17.16b, #0
+.endm
+
+.macro SAD_12
+    ld1         {v0.16b}, [x0], x1
+    and         v0.16b, v0.16b, v31.16b
+    ld1         {v1.16b}, [x2], x3
+    and         v1.16b, v1.16b, v31.16b
+    ld1         {v2.16b}, [x0], x1
+    and         v2.16b, v2.16b, v31.16b
+    ld1         {v3.16b}, [x2], x3
+    and         v3.16b, v3.16b, v31.16b
+    uabal       v16.8h,  v0.8b,  v1.8b
+    uabal2      v17.8h,  v0.16b, v1.16b
+    uabal       v16.8h,  v2.8b,  v3.8b
+    uabal2      v17.8h,  v2.16b, v3.16b
+.endm
+
+.macro SAD_END_12
+    add         v16.8h, v16.8h, v17.8h
+    uaddlv      s0,  v16.8h
+    fmov        w0,  s0
+    ret
+.endm
+
+.macro SAD_START_24
+    movi        v16.16b, #0
+    movi        v17.16b, #0
+    movi        v18.16b, #0
+    sub         x1, x1, #16
+    sub         x3, x3, #16
+.endm
+
+.macro SAD_24
+    ld1         {v0.16b}, [x0], #16
+    ld1         {v1.8b}, [x0], x1
+    ld1         {v2.16b}, [x2], #16
+    ld1         {v3.8b}, [x2], x3
+    ld1         {v4.16b}, [x0], #16
+    ld1         {v5.8b}, [x0], x1
+    ld1         {v6.16b}, [x2], #16
+    ld1         {v7.8b}, [x2], x3
+    uabal       v16.8h,  v0.8b,  v2.8b
+    uabal2      v17.8h,  v0.16b, v2.16b
+    uabal       v18.8h,  v1.8b,  v3.8b
+    uabal       v16.8h,  v4.8b,  v6.8b
+    uabal2      v17.8h,  v4.16b, v6.16b
+    uabal       v18.8h,  v5.8b,  v7.8b
+.endm
+
+.macro SAD_END_24
+    add         v16.8h, v16.8h, v17.8h
+    add         v16.8h, v16.8h, v18.8h
+    uaddlv      s0,  v16.8h
+    fmov        w0,  s0
+    ret
+.endm
+
+.macro SAD_START_48
+    movi        v16.16b, #0
+    movi        v17.16b, #0
+    movi        v18.16b, #0
+    movi        v19.16b, #0
+    movi        v20.16b, #0
+    movi        v21.16b, #0
+.endm
+
+.macro SAD_48
+.rept 2
+    ld1         {v0.16b-v2.16b}, [x0], x1
+    ld1         {v4.16b-v6.16b}, [x2], x3
+    uabal       v16.8h,  v0.8b,  v4.8b
+    uabal2      v17.8h,  v0.16b, v4.16b
+    uabal       v18.8h,  v1.8b,  v5.8b
+    uabal2      v19.8h,  v1.16b, v5.16b
+    uabal       v20.8h,  v2.8b,  v6.8b
+    uabal2      v21.8h,  v2.16b, v6.16b
+.endr
+.endm
+
+.macro SAD_END_48
+    add         v16.8h, v16.8h, v17.8h
+    add         v17.8h, v18.8h, v19.8h
+    add         v16.8h, v16.8h, v17.8h
+    uaddlv      s0,  v16.8h
+    fmov        w0,  s0
+    add         v18.8h, v20.8h, v21.8h
+    uaddlv      s1,  v18.8h
+    fmov        w1,  s1
+    add         w0, w0, w1
+    ret
+.endm
+
+// Fully unrolled.
+.macro SAD_FUNC w, h
+function x265_pixel_sad_\w\()x\h\()_neon
+    SAD_START_\w
+
+.rept \h / 2 - 1
+    SAD_\w
+.endr
+.if \w > 4
+    add         v16.8h,  v16.8h,  v17.8h
+.endif
+    uaddlv      s0,  v16.8h
+    fmov        w0,  s0
+    ret
+endfunc
+.endm
+
+// Loop unrolled 4.
+.macro SAD_FUNC_LOOP w, h
+function x265_pixel_sad_\w\()x\h\()_neon
+    SAD_START_\w
+
+    mov w9, #\h/8
+.loop_\w\()x\h:
+    sub        w9, w9, #1
+.rept 4
+    SAD_\w
+.endr
+    cbnz        w9, .loop_\w\()x\h
+
+    SAD_END_\w
+endfunc
+.endm
+
+SAD_FUNC  4,  4
+SAD_FUNC  4,  8
+SAD_FUNC  4,  16
+SAD_FUNC  8,  4
+SAD_FUNC  8,  8
+SAD_FUNC  8,  16
+SAD_FUNC  8,  32
+SAD_FUNC  16, 4
+SAD_FUNC  16, 8
+SAD_FUNC  16, 12
+SAD_FUNC  16, 16
+SAD_FUNC  16, 32
+SAD_FUNC  16, 64
+
+SAD_FUNC_LOOP  32, 8
+SAD_FUNC_LOOP  32, 16
+SAD_FUNC_LOOP  32, 24
+SAD_FUNC_LOOP  32, 32
+SAD_FUNC_LOOP  32, 64
+SAD_FUNC_LOOP  64, 16
+SAD_FUNC_LOOP  64, 32
+SAD_FUNC_LOOP  64, 48
+SAD_FUNC_LOOP  64, 64
+SAD_FUNC_LOOP  12, 16
+SAD_FUNC_LOOP  24, 32
+SAD_FUNC_LOOP  48, 64
+
 .macro SAD_X_START_8 x
     ld1             {v0.8b}, [x0], x9
 .if \x == 3
@@ -103,3 +390,7 @@ SAD_X_8xN 4 4
 SAD_X_8xN 4 8
 SAD_X_8xN 4 16
 SAD_X_8xN 4 32
+
+const sad12_mask, align=8
+.byte 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 0, 0, 0, 0
+endconst
-- 
2.25.1

